# Joomla\Tabaoca\Package\Cotton

**Description:**
Cotton Cloud is a database file storage system extension developed for Joomla!®.

**Installation:**
1. Download the package.
2. Access the Joomla admin panel.
3. Go to System > Install > Extensions.
4. Select the package file and click Install.
5. Add a menu item Cotton Cloud.

**Configuration:**
1. Access the Joomla admin panel.
2. Go to System > Setup > Global Configuration.
3. Select Cotton Cloud in the list.
4. Configuration:
    * Header
    * Space limit per user
    * Text file types
    * Image file types
    * Video file types
    * Audio file types

**Server Configuration**
For this component to work properly, your server must be configured with the following parameters:

* **PHP:**
* post_max_size: 1G
* upload_max_filesize: 1G
* memory_limit: 1G

* **MySQL:**
* max_allowed_packet: 1073741824

* **Instructions:**
* **PHP:**
Edit the php.ini file or use your server's control panel to modify the directives.
* **MySQL:**
Edit the my.cnf file or use the MySQL console to modify the max_allowed_packet directive.

* **Note:**
The above values ​​are only suggestions. Adjust them according to the specific needs of your component and the recommendations of your hosting provider.

**Usage**
The Cotton Cloud component, by limiting CodeMirror editing to text files, provides a more intuitive and secure user experience. By allowing direct editing of text files, the system makes it easy to create and edit documents, codes and other textual content directly in the browser.

* **File Upload:**
The user can upload various types of files (text, image, video, audio and others) to the system.

* **Editing:**
* **Text Files:**
If the extension corresponds to a text file type (as defined in "Text file types"), the system loads the file content in a CodeMirror editor, allowing the user to edit the text directly in the browser.

* **Other File Types:**
For other file types (image, video, audio and others), the system displays a preview and offers download options, but does not allow direct editing, as they are not configured to be edited.

## Important Notice about the Privacy of Your Data

**By using this system, you agree that the database administrator may have access to the files you upload, even if they are stored in encrypted form.**

**What this means:**

* **Potential Access:**
The database administrator, due to his/her permissions, has the technical ability to access the stored data, including your files.

* **Encryption:**
Although the data is encrypted to protect your privacy, the database administrator has the keys or tools necessary to decrypt the data if he/she so desires.

**Recommendations:**

* **Avoid sending sensitive information:**
Do not send sensitive information, such as financial data, health information, or passwords, through this system.

* **See the privacy policy:**
For more detailed information about how your data is collected, stored, and used, see the full privacy policy.

**Important:**
This information is provided to ensure transparency and to allow you to make informed decisions about using this system. If you have any questions or concerns, please contact our support team.

## License

**Copyright (C) 2024 Jonatas C. Ferreira. All rights reserved.**

**GNU/AGPL v3 https://www.gnu.org/licenses/agpl-3.0.html**